| The Gaudi Framework v32r1 (f65d50dc)

Classes | Public Member Functions | Private Member Functions | Private Attributes | List of all members
GaudiSequencer Class Reference

Sequencer for executing several algorithms, stopping when one is faulty. More...

`#include <GaudiAlg/GaudiSequencer.h>`

Inheritance diagram for GaudiSequencer:
[legend]
Collaboration diagram for GaudiSequencer:
[legend]

## Classes
class | AlgorithmEntry

## Public Member Functions
StatusCode | initialize () override
StatusCode | execute (const EventContext &ctx) const override
StatusCode | sysExecute (const EventContext &ctx) override
std::ostream & | toControlFlowExpression (std::ostream &os) const override
| Produce string represention of the control flow expression. More...
template<typename U = PBASE, typename = std::enable_if_t<std::is_base_of_v<Gaudi::Algorithm, PBASE>, U>>
| GaudiCommon (const std::string &name, ISvcLocator *pSvcLocator)
| Standard constructor. More...
template<typename U = PBASE, typename = std::enable_if_t<std::is_base_of_v<AlgTool, PBASE>, U>>
| GaudiCommon (const std::string &type, const std::string &name, const IInterface *ancestor)
| Standard constructor. More...
Public Member Functions inherited from GaudiCommon< Gaudi::Sequence >
Gaudi::Utils::GetData< TYPE >::return_type | get (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Quicker version of the get function which bypasses the check on the retrieved data. More...
bool | exist (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
DataObject * | put (IDataProviderSvc *svc, std::unique_ptr< DataObject > object, const std::string &location, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
DataObject * | put (IDataProviderSvc *svc, DataObject *object, const std::string &location, const bool useRootInTES=true) const
TOOL * | tool (const std::string &type, const std::string &name, const IInterface *parent=0, bool create=true) const
| Useful method for the easy location of tools. More...
TOOL * | tool (const std::string &type, const IInterface *parent=0, bool create=true) const
| A useful method for the easy location of tools. More...
SmartIF< SERVICE > | svc (const std::string &name, const bool create=true) const
| A useful method for the easy location of services. More...
IUpdateManagerSvc * | updMgrSvc () const
| Short-cut to locate the Update Manager Service. More...
WARN_UNUSED StatusCode | Error (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the error message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Warning (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the warning message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Info (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const size_t mx=10) const
| Print the info message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Print (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const MSG::Level lev=MSG::INFO) const
| Print the message and return with the given StatusCode. More...
void | Assert (const bool ok, const std::string &message="", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Assert (const bool ok, const char *message, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Exception (const std::string &msg, const GaudiException &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given GaudiException. More...
void | Exception (const std::string &msg, const std::exception &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given exception. More...
void | Exception (const std::string &msg="no message", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and throw an exception with the given message. More...
StatEntity & | counter (const std::string &tag) const
| accessor to certain counter by name More...
StatEntity & | counter (const std::string &tag)
bool | typePrint () const
| Insert the actual C++ type of the algorithm/tool in the messages ? More...
bool | propsPrint () const
| Print properties at initialization ? More...
bool | statPrint () const
| Print statistical counters at finalization ? More...
bool | errorsPrint () const
| Print error counters at finalization ? More...
long | printStat (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of statistical counters More...
long | printErrors (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of error counters More...
long | printProps (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of properties More...
void | registerCondition (const std::string &condition, StatusCode(CallerClass::*mf)()=nullptr)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (const std::string &condition, CondType *&condPtrDest, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (char *condition, StatusCode(CallerClass::*mf)()=NULL)
| just to avoid conflicts with the version using a pointer to a template class. More...
void | registerCondition (TargetClass *condition, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
StatusCode | runUpdate ()
| asks the UpdateManagerSvc to perform an update of the instance (if needed) without waiting the next BeginEvent incident. More...
| GaudiCommon (const std::string &name, ISvcLocator *pSvcLocator)
| Algorithm constructor - the SFINAE constraint below ensures that this is constructor is only defined if PBASE derives from Algorithm. More...
| GaudiCommon (const std::string &type, const std::string &name, const IInterface *ancestor)
| Tool constructor - SFINAE-ed to insure this constructor is only defined if PBASE derives from AlgTool. More...
StatusCode | initialize () override
| standard initialization method More...
StatusCode | finalize () override
| standard finalization method More...
StatusCode | release (const IInterface *interface) const
| Manual forced (and 'safe') release of the active tool or service. More...
const Services & | services () const
| get the list of aquired services More...
const std::string & | context () const
| Returns the "context" string. Used to identify different processing states. More...
Public Member Functions inherited from FixTESPath< BASE >
template<typename U = BASE, typename = std::enable_if_t<std::is_base_of_v<Gaudi::Algorithm, BASE>, U>>
| FixTESPath (const std::string &name, ISvcLocator *pSvcLocator)
| Algorithm constructor - the SFINAE constraint below ensures that this is constructor is only defined if BASE derives from Algorithm. More...
template<typename U = BASE, typename = std::enable_if_t<std::is_base_of_v<AlgTool, BASE>, U>>
| FixTESPath (const std::string &type, const std::string &name, const IInterface *ancestor)
| Tool constructor - SFINAE-ed to insure this constructor is only defined if BASE derives from AlgTool. More...
StatusCode | initialize () override
const std::string & | rootInTES () const
| Returns the "rootInTES" string. More...
std::string | fullTESLocation (std::string_view location, bool useRootInTES) const
| Returns the full correct event location given the rootInTes settings. More...

## Private Member Functions
StatusCode | decodeNames ()
| Decode a vector of string. More...
void | membershipHandler ()
| for asynchronous changes in the list of algorithms More...

## Private Attributes
Gaudi::Property< std::vector< std::string > > | m_vetoObjs
Gaudi::Property< std::vector< std::string > > | m_requireObjs
Gaudi::Property< std::vector< std::string > > | m_names
Gaudi::Property< bool > | m_sequential = {this, "Sequential", false, "execute members one at a time"}
Gaudi::Property< bool > | m_modeOR = {this, "ModeOR", false, "use OR logic instead of AND"}
Gaudi::Property< bool > | m_ignoreFilter = {this, "IgnoreFilterPassed", false, "always continue"}
Gaudi::Property< bool > | m_measureTime = {this, "MeasureTime", false, "measure time"}
Gaudi::Property< bool > | m_returnOK = {this, "ReturnOK", false, "forces the sequencer to return a good status"}
Gaudi::Property< bool > | m_shortCircuit = {this, "ShortCircuit", true, "stop processing as soon as possible"}
Gaudi::Property< bool > | m_invert = {this, "Invert", false, "invert the logic result of the sequencer"}
std::vector< AlgorithmEntry > | m_entries
| List of algorithms to process. More...
ISequencerTimerTool * | m_timerTool = nullptr
| Pointer to the timer tool. More...
int | m_timer
| Timer number for the sequencer. More...

## Additional Inherited Members
Protected Types inherited from GaudiCommon< Gaudi::Sequence >
using | base_class = FixTESPath< Gaudi::Sequence >
typedef std::map< std::string, StatEntity > | StatisticsOwn
| the actual type of general counters More...
typedef std::map< std::string, std::reference_wrapper< Gaudi::Accumulators::PrintableCounter > > | Statistics
typedef std::map< std::string, unsigned int > | Counter
| the actual type error/warning counter More...
typedef std::vector< IAlgTool * > | AlgTools
| storage for active tools More...
typedef std::vector< SmartIF< IService > > | Services
| storage for active services More...
Protected Member Functions inherited from GaudiCommon< Gaudi::Sequence >
StatusCode | releaseTool (const IAlgTool *tool) const
| manual forced (and 'safe') release of the tool More...
StatusCode | releaseSvc (const IInterface *svc) const
| manual forced (and 'safe') release of the service More...
Protected Attributes inherited from GaudiCommon< Gaudi::Sequence >
SmartIF< ICounterSummarySvc > | m_counterSummarySvc
| a pointer to the CounterSummarySvc More...
Static Protected Attributes inherited from GaudiCommon< Gaudi::Sequence >
static const bool | IgnoreRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...
static const bool | UseRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...

## Detailed Description

Sequencer for executing several algorithms, stopping when one is faulty.

Default behaviour (ModeOR=False) is to execute all algorithms until one returns filterPassed() = False. If ShortCircuit is set to False, then all algorithms will be executed.

In OR mode, the logic is opposite. All algorithms until one returns filterPassed() = True. To then exit one must conter-intuitively set ShortCircuit to False. If the default value ShortCircuit=True is left then all algorithms will be executed.

Author
  Olivier Callot

Date
  2004-05-13

Definition at line 28 of file GaudiSequencer.h.

## Member Function Documentation

## ◆ decodeNames()

StatusCode GaudiSequencer::decodeNames | ( |  | ) |
| private

Decode a vector of string.

Definition at line 172 of file GaudiSequencer.cpp.

172 {
173 StatusCode final = StatusCode::SUCCESS;
174 m_entries.clear();
175
176 //== Get the "Context" option if in the file...
177 auto jos = service<IJobOptionsSvc>( "JobOptionsSvc" );
178
179 //= Get the Application manager, to see if algorithm exist
180 auto appMgr = service<IAlgManager>( "ApplicationMgr" );
181 for ( const auto& item : m_names.value() ) {
182 const Gaudi::Utils::TypeNameString typeName( item );
183 const std::string& theName = typeName.name();
184 const std::string& theType = typeName.type();
185
186 //== Check wether the specified algorithm already exists. If not, create it
187 StatusCode result = StatusCode::SUCCESS;
188 SmartIF<IAlgorithm> myIAlg = appMgr->algorithm( typeName, false ); // do not create it now
189 if ( !myIAlg ) {
190 // ensure some magic properties are set while we create the subalgorithm so
191 // that it effectively inherites 'our' settings -- if they have non-default
192 // values... and are not set explicitly already.
193 populate_JobOptionsSvc_t populate_guard{theName, jos, std::forward_as_tuple( "Context", context() ),
194 std::forward_as_tuple( "RootInTES", rootInTES() )};
195 Gaudi::Algorithm* myAlg = nullptr;
196 result = createSubAlgorithm( theType, theName, myAlg );
197 myIAlg = myAlg; // ensure that myIAlg.isValid() from here onwards!
198 } else {
199 Gaudi::Algorithm* myAlg = dynamic_cast<Gaudi::Algorithm*>( myIAlg.get() );
200 if ( myAlg ) {
201 subAlgorithms()->push_back( myAlg );
202 // when the algorithm is not created, the ref count is short by one, so we have to fix it.
203 myAlg->addRef();
204 }
205 }
206
207 // propagate the sub-algorithm into own state.
208 if ( result.isSuccess() && Gaudi::StateMachine::INITIALIZED <= FSMState() && myIAlg &&
209 Gaudi::StateMachine::INITIALIZED > myIAlg->FSMState() ) {
210 StatusCode sc = myIAlg->sysInitialize();
211 if ( sc.isFailure() ) result = sc;
212 }
213
214 // propagate the sub-algorithm into own state.
215 if ( result.isSuccess() && Gaudi::StateMachine::RUNNING <= FSMState() && myIAlg &&
216 Gaudi::StateMachine::RUNNING > myIAlg->FSMState() ) {
217 StatusCode sc = myIAlg->sysStart();
218 if ( sc.isFailure() ) result = sc;
219 }
220
221 //== Is it an Algorithm ? Strange test...
222 if ( result.isSuccess() ) {
223 // TODO: (MCl) it is possible to avoid the dynamic_cast in most of the
224 // cases by keeping the result of createSubAlgorithm.
225 Gaudi::Algorithm* myAlg = dynamic_cast<Gaudi::Algorithm*>( myIAlg.get() );
226 if ( myAlg ) {
227 // Note: The reference counting is kept by the system of sub-algorithms
228 m_entries.emplace_back( myAlg );
229 if ( msgLevel( MSG::DEBUG ) ) debug() << "Added algorithm " << theName << endmsg;
230 } else {
231 warning() << theName << " is not a Gaudi::Algorithm - failed dynamic_cast" << endmsg;
232 final = StatusCode::FAILURE;
233 }
234 } else {
235 warning() << "Unable to find or create " << theName << endmsg;
236 final = result;
237 }
238 }
239
240 //== Print the list of algorithms
241 MsgStream& msg = info();
242 if ( m_modeOR ) msg << "OR ";
243 msg << "Member list: ";
244 GaudiUtils::details::ostream_joiner( msg, m_entries, ", ",
245 []( auto& os, const AlgorithmEntry& e ) -> decltype( auto ) {
246 Gaudi::Algorithm* alg = e.algorithm();
247 std::string typ = System::typeinfoName( typeid( *alg ) );
248 os << typ;
249 if ( alg->name() != typ ) os << "/" << alg->name();
250 return os;
251 } );
252 if ( !isDefault( context() ) ) msg << ", with context '" << context() << "'";
253 if ( !isDefault( rootInTES() ) ) msg << ", with rootInTES '" << rootInTES() << "'";
254 msg << endmsg;
255
256 return final;
257 }
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
Gaudi::StateMachine::INITIALIZED
Definition: StateMachine.h:15
SmartIF< IAlgorithm >
ManySmallAlgs.alg
alg
Definition: ManySmallAlgs.py:69
std::forward_as_tuple
T forward_as_tuple(T... args)
IAlgorithm::sysStart
virtual StatusCode sysStart()=0
Startup method invoked by the framework.
System::typeinfoName
GAUDI_API const std::string typeinfoName(const std::type_info &)
Get platform independent information about the class type.
Definition: System.cpp:298
MSG::DEBUG
Definition: IMessageSvc.h:15
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
SmartIF::get
TYPE * get() const
Get interface pointer.
Definition: SmartIF.h:76
IAlgorithm::sysInitialize
virtual StatusCode sysInitialize()=0
Initialization method invoked by the framework.
std::string
STL class.
Gaudi::Utils::TypeNameString
Helper class to parse a string of format "type/name".
Definition: TypeNameString.h:10
GaudiSequencer::m_names
Gaudi::Property< std::vector< std::string > > m_names
Definition: GaudiSequencer.h:70
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
StatusCode::isSuccess
bool isSuccess() const
Definition: StatusCode.h:267
GaudiCommon< Gaudi::Sequence >::context
const std::string & context() const
Returns the "context" string. Used to identify different processing states.
Definition: GaudiCommon.h:707
GaudiSequencer::m_modeOR
Gaudi::Property< bool > m_modeOR
Definition: GaudiSequencer.h:73
GaudiUtils::details::ostream_joiner
Stream & ostream_joiner(Stream &os, Iterator first, Iterator last, Separator sep, OutputElement output=OutputElement{})
Definition: SerializeSTL.h:37
FixTESPath::rootInTES
const std::string & rootInTES() const
Returns the "rootInTES" string.
Definition: FixTESPath.h:52
Gaudi::StateMachine::RUNNING
Definition: StateMachine.h:16
Gaudi::Algorithm
Base class from which all concrete algorithm classes should be derived.
Definition: Algorithm.h:79
IOTest.appMgr
appMgr
Definition: IOTest.py:92
GaudiMP.FdsRegistry.msg
msg
Definition: FdsRegistry.py:8
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
StatusCode::isFailure
bool isFailure() const
Definition: StatusCode.h:130
GaudiDict::typeName
std::string typeName(const std::type_info &typ)
Definition: Dictionary.cpp:21
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
GaudiSequencer::m_entries
std::vector< AlgorithmEntry > m_entries
List of algorithms to process.
Definition: GaudiSequencer.h:80

## ◆ execute()

StatusCode GaudiSequencer::execute | ( | const EventContext & | ctx | ) | const
| override

Definition at line 107 of file GaudiSequencer.cpp.

107 {
108
109 if ( m_measureTime ) m_timerTool->start( m_timer );
110
111 if ( msgLevel( MSG::DEBUG ) ) debug() << "==> Execute" << endmsg;
112
113 StatusCode result = StatusCode( StatusCode::SUCCESS, true );
114
115 bool seqPass = !m_modeOR; // for OR, result will be false, unless (at least) one is true
116 // for AND, result will be true, unless (at least) one is false
117 // also see comment below ....
118
119 for ( auto& entry : m_entries ) {
120 Gaudi::Algorithm* myAlg = entry.algorithm();
121 if ( !myAlg->isEnabled() ) continue;
122 if ( myAlg->execState( ctx ).state() != AlgExecState::State::Done ) {
123
124 if ( m_measureTime ) m_timerTool->start( entry.timer() );
125 result = myAlg->sysExecute( ctx );
126 if ( m_measureTime ) m_timerTool->stop( entry.timer() );
127 if ( !result.isSuccess() ) break; //== Abort and return bad status
128 }
129 //== Check the returned status
130 if ( !m_ignoreFilter ) {
131 bool passed = myAlg->execState( ctx ).filterPassed();
132 if ( msgLevel( MSG::VERBOSE ) )
133 verbose() << "Algorithm " << myAlg->name() << " returned filter passed " << ( passed ? "true" : "false" )
134 << endmsg;
135 if ( entry.reverse() ) passed = !passed;
136
137 //== indicate our own result. For OR, exit as soon as true.
138 // If no more, will exit with false.
139 //== for AND, exit as soon as false. Else, will be true (default)
140
141 // if not short-circuiting, make sure we latch iPass to 'true' in
142 // OR mode (i.e. it is sufficient for one item to be true in order
143 // to be true at the end, and thus we start out at 'false'), and latch
144 // to 'false' in AND mode (i.e. it is sufficient for one item to
145 // be false to the false in the end, and thus we start out at 'true')
146 // -- i.e. we should not just blindly return the 'last' passed status!
147
148 // or to put it another way: in OR mode, we don't care about things
149 // which are false, as they leave our current state alone (provided
150 // we stared as 'false'!), and in AND mode, we keep our current
151 // state until someone returns 'false' (provided we started as 'true')
152 if ( m_modeOR ? passed : !passed ) {
153 seqPass = passed;
154 if ( msgLevel( MSG::VERBOSE ) ) verbose() << "SeqPass is now " << ( seqPass ? "true" : "false" ) << endmsg;
155 if ( m_shortCircuit ) break;
156 }
157 }
158 }
159 if ( msgLevel( MSG::VERBOSE ) ) verbose() << "SeqPass is " << ( seqPass ? "true" : "false" ) << endmsg;
160 auto& state = execState( ctx );
161 if ( !m_ignoreFilter && !m_entries.empty() ) state.setFilterPassed( m_invert ? !seqPass : seqPass );
162 state.setState( AlgExecState::State::Done );
163
164 if ( m_measureTime ) m_timerTool->stop( m_timer );
165
166 return m_returnOK ? ( result.ignore(), StatusCode::SUCCESS ) : result;
167 }
GaudiSequencer::m_measureTime
Gaudi::Property< bool > m_measureTime
Definition: GaudiSequencer.h:75
MSG::DEBUG
Definition: IMessageSvc.h:15
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
AlgExecState::filterPassed
bool filterPassed() const
Definition: IAlgExecStateSvc.h:31
MSG::VERBOSE
Definition: IMessageSvc.h:15
GaudiSequencer::m_timerTool
ISequencerTimerTool * m_timerTool
Pointer to the timer tool.
Definition: GaudiSequencer.h:81
GaudiSequencer::m_ignoreFilter
Gaudi::Property< bool > m_ignoreFilter
Definition: GaudiSequencer.h:74
GaudiSequencer::m_invert
Gaudi::Property< bool > m_invert
Definition: GaudiSequencer.h:78
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
AlgExecState::state
State state() const
Definition: IAlgExecStateSvc.h:32
compareRootHistos.state
def state
Definition: compareRootHistos.py:455
StatusCode::isSuccess
bool isSuccess() const
Definition: StatusCode.h:267
GaudiSequencer::m_modeOR
Gaudi::Property< bool > m_modeOR
Definition: GaudiSequencer.h:73
GaudiSequencer::m_shortCircuit
Gaudi::Property< bool > m_shortCircuit
Definition: GaudiSequencer.h:77
ISequencerTimerTool::start
virtual void start(int index)=0
start the counter, i.e.
StatusCode::ignore
const StatusCode & ignore() const
Ignore/check StatusCode.
Definition: StatusCode.h:153
Gaudi::Algorithm::execState
AlgExecState & execState(const EventContext &ctx) const override
reference to AlgExecState of Alg
Definition: Algorithm.cpp:657
genconfuser.verbose
verbose
Definition: genconfuser.py:19
Gaudi::Algorithm
Base class from which all concrete algorithm classes should be derived.
Definition: Algorithm.h:79
GaudiSequencer::m_returnOK
Gaudi::Property< bool > m_returnOK
Definition: GaudiSequencer.h:76
Gaudi::Algorithm::isEnabled
bool isEnabled() const override
Is this algorithm enabled or disabled?
Definition: Algorithm.cpp:655
ISequencerTimerTool::stop
virtual double stop(int index)=0
stop the counter, return the elapsed time
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
GaudiSequencer::m_timer
int m_timer
Timer number for the sequencer.
Definition: GaudiSequencer.h:82
GaudiSequencer::m_entries
std::vector< AlgorithmEntry > m_entries
List of algorithms to process.
Definition: GaudiSequencer.h:80
Gaudi::Algorithm::name
const std::string & name() const override
The identifying name of the algorithm object.
Definition: Algorithm.cpp:645
Gaudi::Algorithm::sysExecute
StatusCode sysExecute(const EventContext &ctx) override
The actions to be performed by the algorithm on an event.
Definition: Algorithm.cpp:438

## ◆ GaudiCommon() [1/2]

template<typename U = PBASE, typename = std::enable_if_t<std::is_base_of_v<AlgTool, PBASE>, U>>

GaudiCommon< PBASE >::GaudiCommon | ( | typename U | = `PBASE`,
|  | typename | = `std::enable_if_t<std::is_base_of_v<AlgTool, PBASE>, U>`
| ) |  |
| inline

Standard constructor.

Definition at line 648 of file GaudiCommon.h.

649 : base_class( type, name, ancestor ) {
650 initGaudiCommonConstructor( this->parent() );
651 }
gaudiComponentHelp.name
name
Definition: gaudiComponentHelp.py:41
GaudiCommon< Gaudi::Sequence >::base_class
FixTESPath< Gaudi::Sequence > base_class
Definition: GaudiCommon.h:93
gaudirun.type
type
Definition: gaudirun.py:142
GaudiCommon< Gaudi::Sequence >::initGaudiCommonConstructor
void initGaudiCommonConstructor(const IInterface *parent=nullptr)
Constructor initializations.
Definition: GaudiCommon.icpp:65

## ◆ GaudiCommon() [2/2]

template<typename U = PBASE, typename = std::enable_if_t<std::is_base_of_v<Gaudi::Algorithm, PBASE>, U>>

GaudiCommon< PBASE >::GaudiCommon | ( | typename U | = `PBASE`,
|  | typename | = `std::enable_if_t<std::is_base_of_v<Gaudi::Algorithm, PBASE>, U>`
| ) |  |
| inline

Standard constructor.

Definition at line 642 of file GaudiCommon.h.

642 : base_class( name, pSvcLocator ) {
643 initGaudiCommonConstructor();
644 }
gaudiComponentHelp.name
name
Definition: gaudiComponentHelp.py:41
GaudiCommon< Gaudi::Sequence >::base_class
FixTESPath< Gaudi::Sequence > base_class
Definition: GaudiCommon.h:93
GaudiCommon< Gaudi::Sequence >::initGaudiCommonConstructor
void initGaudiCommonConstructor(const IInterface *parent=nullptr)
Constructor initializations.
Definition: GaudiCommon.icpp:65

## ◆ initialize()

StatusCode GaudiSequencer::initialize | ( |  | ) |
| override

Definition at line 73 of file GaudiSequencer.cpp.

73 {
74 // Note: not calling base class initialize because we want to reimplement the loop over sub algs
75 if ( msgLevel( MSG::DEBUG ) ) debug() << "==> Initialise" << endmsg;
76
77 auto status = decodeNames();
78 if ( !status.isSuccess() ) return status;
79
80 m_timerTool = tool<ISequencerTimerTool>( "SequencerTimerTool" );
81
82 if ( m_timerTool->globalTiming() ) m_measureTime = true;
83
84 if ( m_measureTime ) {
85 m_timer = m_timerTool->addTimer( name() );
86 m_timerTool->increaseIndent();
87 } else {
88 release( m_timerTool );
89 m_timerTool = nullptr;
90 }
91
92 //== Initialize the algorithms
93 for ( auto& entry : m_entries ) {
94 if ( m_measureTime ) { entry.setTimer( m_timerTool->addTimer( entry.algorithm()->name() ) ); }
95
96 status = entry.algorithm()->sysInitialize();
97 if ( !status.isSuccess() ) { return Error( "Can not initialize " + entry.algorithm()->name(), status ); }
98 }
99 if ( m_measureTime ) m_timerTool->decreaseIndent();
100
101 return StatusCode::SUCCESS;
102 }
GaudiSequencer::m_measureTime
Gaudi::Property< bool > m_measureTime
Definition: GaudiSequencer.h:75
ISequencerTimerTool::decreaseIndent
virtual void decreaseIndent()=0
Decrease the indentation of the name.
gaudiComponentHelp.name
name
Definition: gaudiComponentHelp.py:41
ISequencerTimerTool::addTimer
virtual int addTimer(const std::string &name)=0
add a timer entry with the specified name
MSG::DEBUG
Definition: IMessageSvc.h:15
GaudiCommon< Gaudi::Sequence >::Error
WARN_UNUSED StatusCode Error(const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
Print the error message and return with the given StatusCode.
Definition: GaudiCommon.icpp:286
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
ISequencerTimerTool::increaseIndent
virtual void increaseIndent()=0
Increase the indentation of the name.
ISequencerTimerTool::globalTiming
virtual bool globalTiming()=0
returns the flag telling that global timing is wanted
GaudiSequencer::m_timerTool
ISequencerTimerTool * m_timerTool
Pointer to the timer tool.
Definition: GaudiSequencer.h:81
GaudiSequencer::decodeNames
StatusCode decodeNames()
Decode a vector of string.
Definition: GaudiSequencer.cpp:172
GaudiCommon< Gaudi::Sequence >::release
StatusCode release(const IInterface *interface) const
Manual forced (and 'safe') release of the active tool or service.
Definition: GaudiCommon.icpp:206
IAlgTool::sysInitialize
virtual StatusCode sysInitialize()=0
Initialization of the Tool.
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
GaudiSequencer::m_timer
int m_timer
Timer number for the sequencer.
Definition: GaudiSequencer.h:82
GaudiSequencer::m_entries
std::vector< AlgorithmEntry > m_entries
List of algorithms to process.
Definition: GaudiSequencer.h:80

## ◆ membershipHandler()

void GaudiSequencer::membershipHandler | ( |  | ) |
| private

for asynchronous changes in the list of algorithms

Definition at line 262 of file GaudiSequencer.cpp.

262 {
263 // no action for not-yet initialized sequencer
264 if ( Gaudi::StateMachine::INITIALIZED > FSMState() ) return; // RETURN
265
266 decodeNames().ignore();
267
268 if ( !m_measureTime ) return; // RETURN
269
270 // add the entries into timer table:
271
272 if ( !m_timerTool ) { m_timerTool = tool<ISequencerTimerTool>( "SequencerTimerTool" ); }
273
274 if ( m_timerTool->globalTiming() ) m_measureTime = true;
275
276 m_timer = m_timerTool->addTimer( name() );
277 m_timerTool->increaseIndent();
278
279 for ( auto& entry : m_entries ) { entry.setTimer( m_timerTool->addTimer( entry.algorithm()->name() ) ); }
280
281 m_timerTool->decreaseIndent();
282 }
GaudiSequencer::m_measureTime
Gaudi::Property< bool > m_measureTime
Definition: GaudiSequencer.h:75
Gaudi::StateMachine::INITIALIZED
Definition: StateMachine.h:15
ISequencerTimerTool::decreaseIndent
virtual void decreaseIndent()=0
Decrease the indentation of the name.
gaudiComponentHelp.name
name
Definition: gaudiComponentHelp.py:41
ISequencerTimerTool::addTimer
virtual int addTimer(const std::string &name)=0
add a timer entry with the specified name
ISequencerTimerTool::increaseIndent
virtual void increaseIndent()=0
Increase the indentation of the name.
ISequencerTimerTool::globalTiming
virtual bool globalTiming()=0
returns the flag telling that global timing is wanted
GaudiSequencer::m_timerTool
ISequencerTimerTool * m_timerTool
Pointer to the timer tool.
Definition: GaudiSequencer.h:81
GaudiSequencer::decodeNames
StatusCode decodeNames()
Decode a vector of string.
Definition: GaudiSequencer.cpp:172
StatusCode::ignore
const StatusCode & ignore() const
Ignore/check StatusCode.
Definition: StatusCode.h:153
GaudiSequencer::m_timer
int m_timer
Timer number for the sequencer.
Definition: GaudiSequencer.h:82
GaudiSequencer::m_entries
std::vector< AlgorithmEntry > m_entries
List of algorithms to process.
Definition: GaudiSequencer.h:80

## ◆ sysExecute()

StatusCode GaudiSequencer::sysExecute | ( | const EventContext & | ctx | ) |
| override

< guard/sentry

Definition at line 306 of file GaudiSequencer.cpp.

306 {
307 StatusCode sc{StatusCode::SUCCESS};
308
309 IAlgContextSvc* algCtx = nullptr;
310 if ( registerContext() ) { algCtx = contextSvc(); }
311 // Lock the context
312 Gaudi::Utils::AlgContext cnt( this, algCtx, ctx );
313
314 // Do not execute if one or more of the m_vetoObjs exist in TES
315 const auto it = find_if( begin( m_vetoObjs ), end( m_vetoObjs ),
316 [&]( const std::string& loc ) { return this->exist<DataObject>( evtSvc(), loc ); } );
317 if ( it != end( m_vetoObjs ) ) {
318 if ( msgLevel( MSG::DEBUG ) ) debug() << *it << " found, skipping event " << endmsg;
319 return sc;
320 }
321
322 // Execute if m_requireObjs is empty
323 // or if one or more of the m_requireObjs exist in TES
324 bool doIt = m_requireObjs.empty() ||
325 any_of( begin( m_requireObjs ), end( m_requireObjs ),
326 [&]( const std::string& loc ) { return this->exist<DataObject>( evtSvc(), loc ); } );
327
328 // execute the generic method:
329 if ( doIt ) sc = GaudiCommon<Gaudi::Sequence>::sysExecute( ctx );
330 return sc;
331 }
Gaudi::Utils::AlgContext
Helper "sentry" class to automatize the safe register/unregister the algorithm's context.
Definition: IAlgContextSvc.h:74
MSG::DEBUG
Definition: IMessageSvc.h:15
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
std::string
STL class.
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
IOTest.end
def end
Definition: IOTest.py:112
std::find_if
T find_if(T... args)
std::any_of
T any_of(T... args)
GaudiCommon
Implements the common functionality between GaudiTools and GaudiAlgorithms.
Definition: GaudiCommon.h:91
IAlgContextSvc
An abstract interface for Algorithm Context Service.
Definition: IAlgContextSvc.h:23
Gaudi::Utils::begin
AttribStringParser::Iterator begin(const AttribStringParser &parser)
Definition: AttribStringParser.h:120
GaudiSequencer::m_requireObjs
Gaudi::Property< std::vector< std::string > > m_requireObjs
Definition: GaudiSequencer.h:67
GaudiSequencer::m_vetoObjs
Gaudi::Property< std::vector< std::string > > m_vetoObjs
Definition: GaudiSequencer.h:65
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ toControlFlowExpression()

std::ostream & GaudiSequencer::toControlFlowExpression | ( | std::ostream & | os | ) | const
| override

Produce string represention of the control flow expression.

Definition at line 284 of file GaudiSequencer.cpp.

284 {
285 if ( m_invert ) os << "~";
286 // the default filterpass value for an empty sequencer depends on ModeOR
287 if ( m_entries.empty() ) return os << ( ( !m_modeOR ) ? "CFTrue" : "CFFalse" );
288
289 // if we have only one element, we do not need a name
290 if ( m_entries.size() > 1 ) os << "seq(";
291
292 const auto op = m_modeOR ? " | " : " & ";
293 const auto last = end( m_entries );
294 const auto first = begin( m_entries );
295 for ( auto iterator = first; iterator != last; ++iterator ) {
296 if ( iterator != first ) os << op;
297 if ( iterator->reverse() ) os << "~";
298 iterator->algorithm()->toControlFlowExpression( os );
299 }
300
301 if ( m_entries.size() > 1 ) os << ")";
302 return os;
303 }
GaudiSequencer::m_invert
Gaudi::Property< bool > m_invert
Definition: GaudiSequencer.h:78
IOTest.end
def end
Definition: IOTest.py:112
GaudiSequencer::m_modeOR
Gaudi::Property< bool > m_modeOR
Definition: GaudiSequencer.h:73
Gaudi::Utils::begin
AttribStringParser::Iterator begin(const AttribStringParser &parser)
Definition: AttribStringParser.h:120
GaudiSequencer::m_entries
std::vector< AlgorithmEntry > m_entries
List of algorithms to process.
Definition: GaudiSequencer.h:80

## Member Data Documentation

## ◆ m_entries

std::vector<AlgorithmEntry> GaudiSequencer::m_entries
| private

List of algorithms to process.

Definition at line 80 of file GaudiSequencer.h.

## ◆ m_ignoreFilter

Gaudi::Property<bool> GaudiSequencer::m_ignoreFilter = {this, "IgnoreFilterPassed", false, "always continue"}
| private

Definition at line 74 of file GaudiSequencer.h.

## ◆ m_invert

Gaudi::Property<bool> GaudiSequencer::m_invert = {this, "Invert", false, "invert the logic result of the sequencer"}
| private

Definition at line 78 of file GaudiSequencer.h.

## ◆ m_measureTime

Gaudi::Property<bool> GaudiSequencer::m_measureTime = {this, "MeasureTime", false, "measure time"}
| private

Definition at line 75 of file GaudiSequencer.h.

## ◆ m_modeOR

Gaudi::Property<bool> GaudiSequencer::m_modeOR = {this, "ModeOR", false, "use OR logic instead of AND"}
| private

Definition at line 73 of file GaudiSequencer.h.

## ◆ m_names

Gaudi::Property<std::vector<std::string> > GaudiSequencer::m_names
| private

Initial value:
= {
this, "Members", {}, &GaudiSequencer::membershipHandler, "list of algorithms"}

Definition at line 70 of file GaudiSequencer.h.

## ◆ m_requireObjs

Gaudi::Property<std::vector<std::string> > GaudiSequencer::m_requireObjs
| private

Initial value:
{
this, "RequireObjects", {}, "execute only if one or more of these TES objects exist"}

Definition at line 67 of file GaudiSequencer.h.

## ◆ m_returnOK

Gaudi::Property<bool> GaudiSequencer::m_returnOK = {this, "ReturnOK", false, "forces the sequencer to return a good status"}
| private

Definition at line 76 of file GaudiSequencer.h.

## ◆ m_sequential

Gaudi::Property<bool> GaudiSequencer::m_sequential = {this, "Sequential", false, "execute members one at a time"}
| private

Definition at line 72 of file GaudiSequencer.h.

## ◆ m_shortCircuit

Gaudi::Property<bool> GaudiSequencer::m_shortCircuit = {this, "ShortCircuit", true, "stop processing as soon as possible"}
| private

Definition at line 77 of file GaudiSequencer.h.

## ◆ m_timer

int GaudiSequencer::m_timer
| private

Timer number for the sequencer.

Definition at line 82 of file GaudiSequencer.h.

## ◆ m_timerTool

ISequencerTimerTool* GaudiSequencer::m_timerTool = nullptr
| private

Pointer to the timer tool.

Definition at line 81 of file GaudiSequencer.h.

## ◆ m_vetoObjs

Gaudi::Property<std::vector<std::string> > GaudiSequencer::m_vetoObjs
| private

Initial value:
{
this, "VetoObjects", {}, "skip execute if one or more of these TES objects exist"}

Definition at line 65 of file GaudiSequencer.h.

The documentation for this class was generated from the following files:

- GaudiAlg/GaudiAlg/GaudiSequencer.h
- GaudiAlg/src/lib/GaudiSequencer.cpp